Option Explicit
' Module: Main
' Purpose:
'     Entry point of application. Declares global
'     variables as well as sets up initial main form
'     contents.

'set in main sub.
Global NEW_LINE
Global DBL_QUOTE
Global TAB_CHAR
Global LAST_CMD_RAN
Global IS_QUIT
Global IS_TAB_CONVERT_ENABLED
Global PREV_SEARCH_TEXT As String
Global PREV_SEARCH_IDX As Integer

Global Const VERSION = "v0.14-RC1"
Global Const BUILD_DATE = "2021-02-16"

Global Const ENTER_KEY = 13
Global Const ESC_KEY = 27
Global Const DELETE_KEY = 46

Global Const NEW_FILE_STR = "(Untitled)"

Global Const ALL_FILES_PATTERN = "*.*"
Global Const COB_FILE_PATTERN = "*.COB"
Global Const CBL_FILE_PATTERN = "*.CBL"
Global Const CPY_FILE_PATTERN = "*.CPY"
Global Const BAT_FILE_PATTERN = "*.BAT"
Global Const TXT_FILE_PATTERN = "*.TXT"
Global Const DEFAULT_FILE_PATTERN = CBL_FILE_PATTERN

Global Const DEFAULT_FILE_EXTENSION = ".CBL"

Global Const WINDOW_STATE_NORMAL = 0
Global Const WINDOW_STATE_MINIMIZED = 1
Global Const WINDOW_STATE_MAXIMIZED = 2

Global Const TEMPLATE_SOURCE_FILE_NAME = "TEMPLATE.DAT"
Global Const TEMPLATE_BUILD_FILE_NAME = "BLDTMPLT.DAT"
Global Const TEMPLATE_TYPE_NONE = 0
Global Const TEMPLATE_TYPE_SOURCE = 1
Global Const TEMPLATE_TYPE_BUILD = 2

Sub Main ()

    'Can't define the global for some reason
    'in the declarations, so it's done here.
    NEW_LINE = Chr(13) & Chr(10)
    DBL_QUOTE = Chr(34)
    TAB_CHAR = Chr(9)
    LAST_CMD_RAN = ""
    IS_QUIT = False
    IS_TAB_CONVERT_ENABLED = False
    PREV_SEARCH_IDX = 1

    Call ResetFileValues(TEMPLATE_TYPE_SOURCE)

    FileControlForm.Visible = True
    MainForm.Visible = True
    
End Sub

