VERSION 2.00
Begin Form SaveFileForm 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Save File"
   ClientHeight    =   3150
   ClientLeft      =   2970
   ClientTop       =   2400
   ClientWidth     =   5250
   Height          =   3555
   Left            =   2910
   LinkTopic       =   "SaveFileForm"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3150
   ScaleWidth      =   5250
   Top             =   2055
   Width           =   5370
   Begin CheckBox ConvertTabsCheck 
      Height          =   435
      Left            =   3840
      TabIndex        =   12
      Top             =   840
      Width           =   255
   End
   Begin TextBox FileNameText 
      Height          =   315
      Left            =   60
      TabIndex        =   0
      Top             =   420
      Width           =   1695
   End
   Begin ComboBox SaveExtensionCombo 
      Height          =   300
      Left            =   60
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   2760
      Width           =   1695
   End
   Begin CommandButton CancelCommand 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   3840
      TabIndex        =   7
      Top             =   480
      Width           =   1335
   End
   Begin CommandButton OkCommand 
      Caption         =   "&OK"
      Height          =   315
      Left            =   3840
      TabIndex        =   5
      Top             =   60
      Width           =   1335
   End
   Begin FileListBox FileSaveControl 
      Height          =   1590
      Left            =   60
      TabIndex        =   1
      Top             =   780
      Width           =   1695
   End
   Begin DriveListBox DriveSaveControl 
      Height          =   315
      Left            =   1800
      TabIndex        =   4
      Top             =   2760
      Width           =   1935
   End
   Begin DirListBox DirSaveControl 
      Height          =   1605
      Left            =   1800
      TabIndex        =   2
      Top             =   780
      Width           =   1935
   End
   Begin Label ConvertTabsLabel 
      Caption         =   "Convert Tabs to Spaces"
      Height          =   675
      Left            =   4080
      TabIndex        =   13
      Top             =   960
      Width           =   1155
   End
   Begin Label FileExtensionLabel 
      Caption         =   "File Extension:"
      Height          =   255
      Left            =   60
      TabIndex        =   11
      Top             =   2460
      Width           =   1695
   End
   Begin Label DrivesLabel 
      Caption         =   "Drives:"
      Height          =   255
      Left            =   1800
      TabIndex        =   10
      Top             =   2460
      Width           =   1935
   End
   Begin Label DirectoryPathLabel 
      Caption         =   "C:\some\example\yep"
      Height          =   315
      Left            =   1800
      TabIndex        =   9
      Top             =   420
      Width           =   1935
   End
   Begin Label DirectoriesLabel 
      Caption         =   "Directories:"
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   120
      Width           =   1515
   End
   Begin Label FileNameLabel 
      Caption         =   "File Name:"
      Height          =   195
      Left            =   60
      TabIndex        =   6
      Top             =   120
      Width           =   1695
   End
End
Option Explicit

Sub CancelCommand_Click ()
    Unload SaveFileForm
End Sub

Sub DirSaveControl_Change ()
    FileSaveControl.Path = DirSaveControl.Path
    DirectoryPathLabel.Caption = DirSaveControl.Path
End Sub

Sub DirSaveControl_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        Dim Selected As String
        Selected = DirSaveControl.List(DirSaveControl.ListIndex)
        DirSaveControl.Path = Selected
        FileSaveControl.Path = DirSaveControl.Path
    ElseIf KeyAscii = ESC_KEY Then
        Unload SaveFileForm
    End If

End Sub

Sub DriveSaveControl_Change ()
    On Error GoTo ErrorHandler
    DirSaveControl.Path = DriveSaveControl.Drive
    
    Exit Sub

ErrorHandler:   ' Error handler line label.
    Dim msg As String
    msg = "ERROR: An unknown error occured."

    Select Case Err
        Case 53: msg = "ERROR 53: That file doesn't exist."
        Case 68: msg = "ERROR 68: Drive not available."
        Case 76: msg = "ERROR 76: That path doesn't exist."
        Case Else: msg = "ERROR " & Err & " occurred." & NEW_LINE & Error$(Err)
    End Select
    MsgBox msg  ' Display error message.
    Resume Next ' Resume procedure.

End Sub

Sub FileNameText_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    ElseIf KeyAscii = ESC_KEY Then
        Unload SaveFileForm
    End If
End Sub

Sub FileSaveControl_Click ()
    Dim SelectedFileName As String
    SelectedFileName = FileSaveControl.List(FileSaveControl.ListIndex)
    FileNameText.Text = SelectedFileName
End Sub

Sub FileSaveControl_DblClick ()
    Dim Overwrite As Integer
    Overwrite = MsgBox("Are you sure you want to overwrite " & FileNameText.Text & "?", MB_ICONQUESTION + MB_YESNO, "Overwrite?")
    If Overwrite = IDYES Then
        OkCommand.Value = True
    End If
End Sub

Sub FileSaveControl_KeyPress (KeyAscii As Integer)
    If KeyAscii = ESC_KEY Then
        Unload SaveFileForm
    End If
End Sub

Sub Form_Load ()
    DriveSaveControl.Drive = FileControlForm.DriveControl.Drive
    DirSaveControl.Path = FileControlForm.DirControl.Path

    SaveExtensionCombo.AddItem DEFAULT_FILE_PATTERN
    SaveExtensionCombo.AddItem CBL_FILE_PATTERN
    SaveExtensionCombo.AddItem CPY_FILE_PATTERN
    SaveExtensionCombo.AddItem BAT_FILE_PATTERN
    SaveExtensionCombo.AddItem TXT_FILE_PATTERN
    SaveExtensionCombo.AddItem ALL_FILES_PATTERN
    SaveExtensionCombo.Text = SaveExtensionCombo.List(0)

    FileSaveControl.Pattern = DEFAULT_FILE_PATTERN
    DirectoryPathLabel.Caption = DirSaveControl.Path

    'preload file name if it's an existing file
    If GetPreviousFileName$() <> NEW_FILE_STR Then
        FileNameText.Text = GetPreviousFileName$()
    End If

    'absolute because true is -1 and checked is 1...
    ConvertTabsCheck.Value = Abs(IsTabConvertEnabled%())
End Sub

Sub Form_Unload (Cancel As Integer)
    MainForm.Enabled = True
    FileControlForm.Enabled = True

    'Exit program is currently flagged to quit
    If IS_QUIT Then
        End
    End If
End Sub

Sub OkCommand_Click ()
    If FileNameText.Text = "" Then
        Exit Sub
    End If

    If ConvertTabsCheck.Value = 1 Then
        Call SetTabConvertEnabled(True)
    Else
        Call SetTabConvertEnabled(False)
    End If
        
    Dim FullFileName As String
    Dim Path As String

    FullFileName = FileNameText.Text

    'if no extension, set based on ext drop down.
    If InStr(FullFileName, ".") = 0 Then
        Dim TempExt As String
        TempExt = Right$(SaveExtensionCombo.Text, 4)
        If TempExt = ALL_FILES_PATTERN Then
            TempExt = DEFAULT_FILE_EXTENSION
        End If
        FullFileName = FullFileName + TempExt
    End If

    Dim FileName As String
    Dim Extension As String

    'break file name string into name and ext.
    FileName = Left$(FullFileName, InStr(FullFileName, "."))
    Extension = Right$(FullFileName, Len(FullFileName) - InStr(FullFileName, "."))

    'fix length if needed of name.
    If Len(FileName) > 9 Then
        FileName = Left$(FileName, 6) + "~1" + "."
    End If

    'fix length of ext if needed.
    If Len(Extension) > 3 Then
        Extension = Left$(Extension, 3)
    End If

    FullFileName = FileName + Extension

    'add \ to path if missing.
    Path = FileSaveControl.Path
    If Right$(Path, 1) <> "\" Then
        Path$ = Path + "\"
    End If
    
    Dim FileContents As String
    FileContents = MainForm.EditorText.Text

    If Not SaveFile%(Path, FullFileName, FileContents) Then
        MsgBox "Error saving file. Please check file name and path and try again.", MB_ICONSTOP, "Error Saving File"
    Else
        'This is a stupid way to force the contents of
        'the directory to refresh. If it's the same path,
        'it won't trigger a directory contents refresh
        'even if there's a new file so need to change to
        'something different and back...
        FileControlForm.DirControl.Path = "\"
        FileControlForm.DirControl.Path = Path
    End If

    'Set main form caption to newly saved file name.
    MainForm.Caption = "NE COBOL Editor - " & LCase$(FullFileName)

    Unload SaveFileForm
End Sub

Sub SaveExtensionCombo_Click ()
    FileSaveControl.Pattern = SaveExtensionCombo.Text
End Sub

